package edu.unika.aifb.owltools.evaluation;

import edu.unika.aifb.owltools.api;
import org.semanticweb.kaon2.api.*;
import org.semanticweb.kaon2.api.owl.axioms.*;

/**
 * Checks if in an ontology all entities have a label.
 */
public class AllLabelled extends Evaluation {
	public AllLabelled(Ontology ontologyToBeEvaluated, String URI, Ontology contextOfEvaluation) { super(ontologyToBeEvaluated, URI, contextOfEvaluation); }
	public String evaluationClassName() { return "AllLabeled"; };
	public String evaluationClassURI() { return "http://owltools.ontoware.org/evaluation/type#alllabeled"; }
	public String evaluationClassDescription() { return "Checks if all the entitites in the ontology have a label."; }
	
	/**
	 * Checks if in an ontology all entities have a label
	 */
	protected boolean evaluate() {
		try {
			int axioms = api.count(ontology);
			int annos = api.count(ontology, Annotation.class);
			if (0==axioms)
				setEvaluation(0.0);
			else
				setEvaluation((annos*1.0) / (axioms*1.0));
		} catch (KAON2Exception k) {
			description = k.toString();
			return false;
		}
		return true;
	}

}
