/*
 * dump just dumps what it understands of a read ontology.
 */
package edu.unika.aifb.owltools.server;

import org.semanticweb.kaon2.api.*;
import edu.unika.aifb.owltools.tools.*;
import org.mortbay.http.*;
import org.mortbay.http.handler.*;
//import org.mortbay.servlet.*;
import org.mortbay.jetty.servlet.*;

public class Server extends KAON2Tool {
	public String name() { return "server"; }
	
	String m_fileuri = "";
	String m_output = "";
	boolean m_count = false;
	
	HttpServer m_server;
	
	public static void main(String[] args) {
		Server server = new Server();
		if (!server.processArguments(args)) return;
		server.compile();
		server.printer.close();
	}

	public boolean processArguments(String[] args) {
		// process command line arguments
		
		int argc = args.length;
		if (argc == 0) {
			printUsage();
			return false;
		}
		String s = args[0].toLowerCase();
		if (argc == 1) {
			if ((s.equalsIgnoreCase("-?")) || (s.equalsIgnoreCase("?")) || (s.equalsIgnoreCase("-h")) || (s.equalsIgnoreCase("--help")) || (s.equalsIgnoreCase("-help")) || (s.equalsIgnoreCase("help")) || (s.equalsIgnoreCase("server"))) {
				printUsage();
				return false;
			}
		}

		boolean hasFileName = false;
		boolean hasOutput = false;
		boolean hasCount = false;
		
		for (int i = 0; i < argc; ++i) {
			boolean unknownArg = true;
			
			String arg = args[i];

			if ((arg.equalsIgnoreCase("-?")) || (arg.equalsIgnoreCase("?")) || (arg.equalsIgnoreCase("-h")) || (arg.equalsIgnoreCase("--help")) || (arg.equalsIgnoreCase("-help")) || (arg.equalsIgnoreCase("help"))) {
				printUsage();
				return false;
			}

			if (arg.startsWith("-")) {
				
				if (arg.equalsIgnoreCase("-stop")) {
					if (hasCount) { printUsageError(); return false; }
					m_count = true;
					hasCount = true;
					unknownArg = false;
				}
								
			} else {
				if (arg.equalsIgnoreCase("server")) {
					unknownArg = false;
				} else {
					if (hasFileName) {
						if (hasOutput) { printUsageError(); return false; }
						m_output = arg;
						hasOutput = true;
						unknownArg = false;
					} else {
						m_fileuri = arg;
						hasFileName = true;					
						unknownArg = false;
					}
				}
			}
			
			if (unknownArg) { printUsageError(); return false; } 
		}
		return true;
	}
	
	public static void server(Ontology ontology, HttpServer localserver) throws KAON2Exception {
		System.out.println("A");
		localserver = new HttpServer();
		SocketListener listener = new SocketListener();
		listener.setPort(5266);
		localserver.addListener(listener);

		HttpContext context = new HttpContext();
		context.setContextPath("/");
		ServletHandler servlets = new ServletHandler();
	    servlets.addServlet("KAON2Servlet","/*","edu.unika.aifb.owltools.server.KaonServer");
	    context.addHandler(servlets);
	      		
		context.addHandler(new DumpHandler());
		context.addHandler(new NotFoundHandler());
		localserver.addContext(context);

		try {
			localserver.start();
		} catch (Exception e) {
			System.out.println(e.toString());
		}
		
		System.out.println("Not implemented yet");
	}
	
	public static void stop(HttpServer localserver) {
		try {
			localserver.stop();
		} catch (Exception e) {
			System.out.println(e.toString());
		}
	}

	public void compile() {
		try {
			if (!m_output.equals("")) printer.setFile(m_output);
			Ontology ontology = loadOntology(m_fileuri);

	        try {
	        	if (!m_count)
	        		server(ontology, m_server);
	        	else {
	        		stop(m_server);
	        	}
	        } catch (KAON2Exception e) {
				printer.error("Could not open ontology " + m_fileuri);
				printer.error(e.toString());
			}
			finally {
				endConnection();
			}
		} catch (KAON2Exception e) {
			printer.error("Could not open or close KAON2 connection.");
			printer.error(e.toString());
		} catch (InterruptedException e) {
			printer.error("Interrupted opening KAON2 connection.");
			printer.error(e.toString());
		}
	}

	/**
	 * prints the command line parameters and a short info
	 */
	public static void printUsage() {
		System.out.println("Usage: owl server <input_url>");
		System.out.println("server starts a http server that provides browsable information of the");
		System.out.println("given ontology.");
		System.out.println("");
		System.out.println(" <input_url>");
		System.out.println("     The location of the ontology to be read.");
	}

}
