package edu.unika.aifb.owltools.utils;

import java.util.*;

import org.semanticweb.kaon2.api.*;
import edu.unika.aifb.owltools.api;

/**
 * Deletes all axioms from an ontology
 */
public class Clear {

	/**
	 * Deletes all axioms from an ontology.
	 * 
	 * @param ontology Ontology to be cleared
	 * @throws KAON2Exception from KAON2
	 */
	static public void clear(Ontology ontology) throws KAON2Exception {
		if (api.count(ontology) == 0) return;
		
		List<OntologyChangeEvent> changes = new ArrayList<OntologyChangeEvent>();
		
		Request<Axiom> request = ontology.createAxiomRequest();
		
		Set<Axiom> axioms = request.get();
		for (Axiom axiom : axioms)
			changes.add(new OntologyChangeEvent(axiom, OntologyChangeEvent.ChangeType.REMOVE));
		
		ontology.applyChanges(changes);
	}
	
}
