package edu.unika.aifb.owltools.utils;

import org.semanticweb.kaon2.api.*;
import org.semanticweb.kaon2.api.logic.*;
import org.semanticweb.kaon2.api.flogic.*;
import org.semanticweb.kaon2.api.owl.axioms.*;
import org.semanticweb.kaon2.api.owl.elements.*;

/**
 * Default implementation of the visitor.
 * 
 * It calls the defaultbehaviour. This may be overwritten, so in case an own visitor
 * is implemented, default error handling behaviour can be created
 */
public class KAON2VisitorAdapter implements org.semanticweb.kaon2.api.KAON2Visitor {
	/**
	 * This is the defaultbehavour called by the visitor. By changing this an
	 * appropriate error handling implementation can be created
	 * @param object The object being visited
	 * @return
	 */
	public Object defaultbehaviour(Object object) {
		return null;
	}
    public Object visit(Predicate object) {
        return defaultbehaviour(object);
    }
    public Object visit(Exists object) {
        return defaultbehaviour(object);
    }
    public Object visit(DefaultNegation object) {
        return defaultbehaviour(object);
    }
    public Object visit(PredicateSymbol object) {
        return defaultbehaviour(object);
    }
    public Object visit(Forall object) {
        return defaultbehaviour(object);
    }
    public Object visit(ClassicalNegation object) {
        return defaultbehaviour(object);
    }
    public Object visit(Conjunction object) { 
        return defaultbehaviour(object);
    }
    public Object visit(QueryDefinition object) {
        return defaultbehaviour(object);
    }
    public Object visit(FMolecule object) { 
        return defaultbehaviour(object);
    }
    public Object visit(Disjunction object) {
        return defaultbehaviour(object);
    }
    public Object visit(FMethodCall object) {
        return defaultbehaviour(object);
    }
    public Object visit(Implication object) {
        return defaultbehaviour(object);
    }
    public Object visit(FunctionalTerm object) {
        return defaultbehaviour(object);
    }
    public Object visit(Equivalence object) { 
        return defaultbehaviour(object);
    }
    public Object visit(Individual object) {
        return defaultbehaviour(object);
    }
    public Object visit(AnnotationProperty object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataProperty object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectProperty object) {
        return defaultbehaviour(object);
    }
    public Object visit(Datatype object) {
        return defaultbehaviour(object);
    }
    public Object visit(OWLClass object) {
        return defaultbehaviour(object);
    }
    public Object visit(Variable object) {
        return defaultbehaviour(object);
    }
    public Object visit(Constant object) {
        return defaultbehaviour(object);
    }
    public Object visit(Literal object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataNot object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataOneOf object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataAll object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataSome object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataCardinality object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataHasValue object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectAll object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectSome object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectCardinality object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectOneOf object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectHasValue object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectNot object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectOr object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectAnd object) {
        return defaultbehaviour(object);
    }
    public Object visit(Rule object) {
        return defaultbehaviour(object);
    }
    public Object visit(SubClassOf object) {
        return defaultbehaviour(object);
    }
    public Object visit(EquivalentClasses object) {
        return defaultbehaviour(object);
    }
    public Object visit(DisjointClasses object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataPropertyAttribute object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataPropertyDomain object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataPropertyRange object) {
        return defaultbehaviour(object);
    }
    public Object visit(SubDataPropertyOf object) {
        return defaultbehaviour(object);
    }
    public Object visit(EquivalentDataProperties object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectPropertyAttribute object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectPropertyDomain object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectPropertyRange object) {
        return defaultbehaviour(object);
    }
    public Object visit(SubObjectPropertyOf object) {
        return defaultbehaviour(object);
    }
    public Object visit(EquivalentObjectProperties object) {
        return defaultbehaviour(object);
    }
    public Object visit(InverseObjectProperties object) {
        return defaultbehaviour(object);
    }
    public Object visit(SameIndividual object) {
        return defaultbehaviour(object);
    }
    public Object visit(DifferentIndividuals object) {
        return defaultbehaviour(object);
    }
    public Object visit(DataPropertyMember object) {
        return defaultbehaviour(object);
    }
    public Object visit(ObjectPropertyMember object) {
        return defaultbehaviour(object);
    }
    public Object visit(ClassMember object) {
        return defaultbehaviour(object);
    }
    public Object visit(Annotation object) {
        return defaultbehaviour(object);
    }
    public Object visit(Deprecation object) {
        return defaultbehaviour(object);
    }
    public Object visit(Ontology object) {
        return defaultbehaviour(object);
    }
    public Object visit(KAON2Connection object) {
        return defaultbehaviour(object);
    }
}
