package edu.unika.aifb.owltools.tools;

import edu.unika.aifb.foam.input.ExplicitRelation;
import edu.unika.aifb.foam.input.MyOntology;
import edu.unika.aifb.foam.main.Align;
import edu.unika.aifb.foam.main.Parameter;
import edu.unika.aifb.foam.util.INRIAAlignmentAPI;
import edu.unika.aifb.foam.util.UserInterface;
import org.semanticweb.kaon2.api.KAON2Manager;
//import org.semanticweb.kaon2.api.OntologyFileFormat;
import org.semanticweb.kaon2.api.formatting.OntologyFileFormat;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;


/**
 * @author Vitaliy Zayets
 * @date 09.09.2006
 * @time 1:15:31
 */
public class Match extends KAON2Tool {

    String m_format = OntologyFileFormat.OWL_XML;

    public static String path = "";
    String m_fileuriBase = "";
    String m_fileuriTarget = "";
    String m_output = "";
    String m_resolver = "";

    boolean m_result = true;

    private static final int SCENARIO = Parameter.NOSCENARIO;
    private static final String EXPLICITFILE = "";


    public String name() {
        return "match";
    }

    public String getLocalPath() {
        String path = "";
        //       try{
        File f = new File("tmp");
        String p = f.getAbsolutePath();
        //      String c = f.getCanonicalPath();
        String tmp = p.substring(0, p.length() - 3);
        //path = p.substring(0,p.length()-3);
        path = tmp.replace('\\', '/');
//        System.out.println("path:" + path);
        //     } catch (IOException io) {io.printStackTrace();}
        return path;
    }

    public static void main(String[] args) {
        Match m = new Match();
        if (!m.processArguments(args)) return;


        m.compile();
        m.printer.close();


    }

    public boolean processArguments(String[] args) {
        int argc = args.length;
        if (argc == 0) {
            printUsage();
            return false;
        }
        String s = args[0].toLowerCase();
        if (argc == 1) {
            if ((s.equalsIgnoreCase("-?")) || (s.equalsIgnoreCase("?")) || (s.equalsIgnoreCase("-h")) || (s.equalsIgnoreCase("--help")) || (s.equalsIgnoreCase("-help")) || (s.equalsIgnoreCase("help")) || (s.equalsIgnoreCase("match")))
            {
                printUsage();
                return false;
            }
        }

        boolean hasFileName1 = false;
        boolean hasFileName2 = false;
        boolean hasOutput = false;
        boolean hasVerbose = false;
        boolean hasFormat = false;
        boolean hasResult = false;
        boolean hasR = false;
        boolean hasResolver = false;

        for (int i = 0; i < argc; ++i) {
            boolean unknownArg = true;

            String arg = args[i];

            if ((arg.equalsIgnoreCase("-?")) || (arg.equalsIgnoreCase("?")) || (arg.equalsIgnoreCase("-h")) || (arg.equalsIgnoreCase("--help")) || (arg.equalsIgnoreCase("-help")) || (arg.equalsIgnoreCase("help")))
            {
                printUsage();
                return false;
            }

            if (arg.startsWith("-")) {
                if ((arg.equalsIgnoreCase("-verbose")) || (arg.equalsIgnoreCase("-verb"))) {
                    if (hasVerbose) {
                        printUsageError();
                        return false;
                    }
                    printer.verbose = true;
                    hasVerbose = true;
                    unknownArg = false;
                }

                if ((arg.equalsIgnoreCase("-noresult")) || (arg.equalsIgnoreCase("-no"))) {
                    if (hasResult) {
                        printUsageError();
                        return false;
                    }
                    m_result = false;
                    hasResult = true;
                    unknownArg = false;
                }

                // Format
                if (arg.equalsIgnoreCase("-rdf")) {
                    if (hasFormat) {
                        printUsageError();
                        return false;
                    }
                    m_format = OntologyFileFormat.OWL_RDF;
                    hasFormat = true;
                    unknownArg = false;
                }
                if (arg.equalsIgnoreCase("-xml")) {
                    if (hasFormat) {
                        printUsageError();
                        return false;
                    }
                    m_format = OntologyFileFormat.OWL_XML;
                    hasFormat = true;
                    unknownArg = false;
                }
                if (arg.equalsIgnoreCase("-r")) {
                    if (hasR || (i < 4 && argc == 6)) {
                        printUsageError();
                        return false;
                    }
                    m_resolver = "resolver.xml";
                    hasR = true;
                    unknownArg = false;
                }

            } else {
                if (arg.equalsIgnoreCase("match")) {
                    unknownArg = false;
                } else {
                    if (hasFileName1) {
                        if (hasFileName2) {
                            if (hasOutput) {
                                if (hasR) {
                                    if (hasResolver) {
                                        printUsageError();
                                        return false;

                                    } else {
                                        m_resolver = arg;
                                        hasResolver = true;
                                        unknownArg = false;
                                        System.out.println("Resolver file:  " + arg);
                                    }
                                }
                            } else {
                                m_output = arg;
                                hasOutput = true;
                                unknownArg = false;
                                System.out.println("Result ontology: " + arg);
                            }
                        } else {
                            m_fileuriTarget = arg;
                            hasFileName2 = true;
                            unknownArg = false;
                            System.out.println("Target ontology: " + arg);
                        }
                    } else {
                        m_fileuriBase = arg;
                        hasFileName1 = true;
                        unknownArg = false;
                        System.out.println("Source ontology: " + arg);
                    }
                }
            }

            if (unknownArg) {
                printUsageError();
                return false;
            }
        }

        if (!hasFileName2) {
            printUsageError();
            return false;
        }
        return true;
    }

    public void compile() {
        path = getLocalPath();
        //String[] properties = getProperties();
        String[] properties={"tree.obj ","rules.obj"};
        //      System.out.println("prop1:" + properties[0]);
        //      System.out.println("prop2:" + properties[1]);

        alignService(m_fileuriBase, m_fileuriTarget, properties);
        //      System.out.println("ok!");
    }

    public void alignService(String ontology1, String ontology2, String[] prop) {

        //String localPath = prop[0];
        String classifierFile = path + "config/" + prop[0];
        String rulesFile = path + "config/" + prop[1];
        UserInterface.useOutput = false;

        try {
            Align align = new Align();                        //creating the new alignment method

            String[] ontologyfiles = new String[2];

            ontologyfiles[0] = ontology1;
            ontologyfiles[1] = ontology2;

            MyOntology ontologies = new MyOntology(ontologyfiles);    //assigning the ontologies

            if (ontologies.ok) {
                ExplicitRelation explicit = new ExplicitRelation(EXPLICITFILE, ontologies);    //assigning pre-known alignments
                Parameter parameter = new Parameter(SCENARIO, ontologyfiles);
                parameter.semi = Parameter.FULLAUTOMATIC;                //not every strategy fits the web service
                if (parameter.maxiterations > 20) {                        // some parts have to be set manually
                    parameter.maxiterations = 20;
                }
                parameter.classifierFile = classifierFile;
                parameter.rulesFile = rulesFile;
                System.out.println("Classifier File:" + classifierFile);
                System.out.println("Rules File:" + rulesFile);
                align.name = "Alignment_" + ontology1 + "_" + ontology2;
                align.ontology = ontologies;
                align.p = parameter;
                align.explicit = explicit;
                System.out.println("Please be patient. Aligment process started...");
                align.align();                                    //process
                System.out.println("Aligment process has been finished.");

                simpleRDFAligment(align.alignments);

            } else {
                System.out.println("Error, could not read ontologies. Please ensure they are codified in OWL-Lite or OWL-DLP.");
            }
        } catch (Exception e) {
            System.out.println("Sorry, an error occurred");
            e.printStackTrace();
        }
    }

    public void simpleRDFAligment(Vector vector) {
        Iterator iter = vector.iterator();

        String [][] array = new String[vector.size()][3];
        int cnt = 0;
        while (iter.hasNext()) {
            String[] element = (String[]) iter.next();

            array[cnt][0] = element[0];
            array[cnt][1] = element[1];
            array[cnt][2] = element[2];

            KAON2Manager.factory().owlClass(array[cnt][0]);

            cnt++;
        }
        INRIAAlignmentAPI api = new INRIAAlignmentAPI();
        String inria = api.ArrayToString(array, "", "");
//        String inria = api.ArrayToString(array, "", "", m_fileuriBase, m_fileuriTarget);

        try {
            if (!m_output.equals("")) {
                File result = new File(m_output);
                FileWriter out = new FileWriter(result);
                out.write(inria);
                out.flush();
                System.out.println("Result has been written to the \"" + result + "\" file.");
            } else {
                System.out.println(inria);
            }
        } catch (IOException io) {
            io.printStackTrace();
        }
    }

    public String[] getProperties() {
        String[] propArray = new String[2];

        try {
            ClassLoader loader = Match.class.getClassLoader();
            Properties props = new Properties();
            //System.out.println(path + "config/" + "props.properties");
            //String name = path + "edu/unika/aifb/owltools/config/" + "props.properties";
            //System.out.println(name);
            File f = new File("aaa");
            //f.getAbsolutePath();
            //System.out.println("path:" + f.getAbsolutePath());
            //String p = "edu/unika/aifb/owltools/config/";
            //String p = f.getAbsolutePath().substring(0,f.getAbsolutePath().lastIndexOf("\\")) + "\\config\\";
            String p = "/config/";
            System.out.println("Path:" + p);
            props.load(loader.getResourceAsStream(p + "props.properties"));
            //System.out.println("Exception!");
            propArray[0] = (String) props.get("classifierFile");
            System.out.println("Classifier file: " + propArray[0]);

            propArray[1] = (String) props.get("rulesFile");
            System.out.println("Rules file     : " + propArray[1]);

        } catch (IOException e) {
            System.out.println("Can't load from property file...");
            e.printStackTrace();
        }
        return propArray;
    }

    public String[][] entityCheck(String[][] array, String onto1, String onto2) {
        String[][] entities = new String[3][];
        return entities;
    }

    /**
     * prints the command line parameters and a short info
     */
    public static void printUsage() {
        System.out.println("Usage: owl match <url1> <url2> [<output_filename>] [-r [<resolver_filename>]] [-verbose] [-rdf|-xml] [-no]");
        System.out.println("");
        System.out.println("match creates matching ontology for two given ontologies");
        System.out.println("");
        System.out.println(" <url1>");
        System.out.println("     The location of the source ontology");
        System.out.println(" <url2>");
        System.out.println("     The location of the target ontology");
        System.out.println(" <output_filename>");
        System.out.println("     The name of the file where the matched ontology will be written to.");
        System.out.println("     If omitted, the result is sent to the console.");
        System.out.println("");
        System.out.println(" <resolver_filename>");
        System.out.println("     The name of the resolver file which include all ontologies used in mapping.");
        System.out.println("     If omitted, the default resolver file name is \"resolver.xml\".");
        System.out.println("");
        System.out.println(" -r");
        System.out.println("     If this switch is set, resolver file will be used in programm in order to");
        System.out.println("     include all necessary ontologies");
        System.out.println("");
        System.out.println(" -verbose or simply -verb");
        System.out.println("     If this switch is set, you will get additional output while processing.");
        System.out.println("");
        System.out.println(" -rdf / -xml");
        System.out.println("     These switches decide the format of the output ontology: either");
        System.out.println("     RDF/XML-serialisation or OWL/XML Presentation Syntax (default)");
        System.out.println("");
        System.out.println(" -noresult or simply -no");
        System.out.println("     Doesn't save or show the result.");
    }
}
