package edu.unika.aifb.owltools.utils;

import org.semanticweb.kaon2.api.*;
import org.semanticweb.kaon2.api.reasoner.*;
import edu.unika.aifb.owltools.api;

public class TimedReasoner extends Thread {

	Ontology ontology;
	Printer printer;
	
	boolean satisfiable = false;
	boolean decided = false; 
	long time = 0;
	
	public void run() {
		try {
			Reasoner reasoner = ontology.createReasoner();
			try {
				long start = System.nanoTime();
				satisfiable = reasoner.isSatisfiable();
				long end = System.nanoTime();
				time = (end-start);
				decided = true;
			} catch (InterruptedException e) {
				decided = false;
			} finally {
				reasoner.dispose();
			}
		} catch (KAON2Exception e) {
			printer.error(e.toString());
		}
	}
	
	public boolean decided() { return decided; }
	public boolean satisfiable() { return satisfiable; }
	public long time() { return time; }
	public void set(Ontology o, Printer p) {
		try {
			ontology = api.deo(o);
		} catch (KAON2Exception e) {
			p.error(e.toString());
		}
		printer = p; 
	}
	
}
